﻿using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.CompilerServices;
using System.Reflection;

namespace System {

   public static class ObjectX {

      [DebuggerStepThrough()]
      public static T CloneX<T>(this T Obj) where T : ICloneable {
         return (T)Obj.Clone();
      }
      [DebuggerStepThrough()]
      public static bool Is<T>(this T itm, object other) { return object.ReferenceEquals(itm, other); }
      [DebuggerStepThrough()]
      public static bool Null<T>(this T Subj) where T : class { return Subj == null; }
      [DebuggerStepThrough()]
      public static bool NotNull<T>(this T Subj) where T : class { return Subj != null; }

      public static void Dbg<T>(this IEnumerable<T> items) {
         var itms = items.GetEnumerator();
         if (itms.MoveNext()) _Dbg(itms.Current, itms);
      }
      public static void Dbg<T>(this T[] items) {
         var itms = items.GetEnumeratorX();
         if (itms.MoveNext()) _Dbg(itms.Current, itms);
      }
      public static void Dbg(this IEnumerable items) {
         var itms = items.GetEnumerator();
         if (itms.MoveNext()) _Dbg(itms.Current, itms);
      }
      public static void Dbg<T>(this T itm0, string txt) {
         _Dbg(itm0, new string[] { txt }.GetEnumerator());
      }
      public static void Dbg<T>(this T itm0, params object[] moreItems) {
         _Dbg(itm0, moreItems.GetEnumerator());
      }
      public static void Dbg<T>(this T itm0, IEnumerable moreItems) {
         _Dbg(itm0, moreItems.GetEnumerator());
      }
      private static int _DbgId;
      private static void _Dbg(object itm0, IEnumerator moreItems) {
         var lst = new List<object>(15);
         lst.Add(_DbgId);
         lst.Add(itm0);
         _DbgId = ++_DbgId % 10;
         while (moreItems.MoveNext()) lst.Add(moreItems.Current);
         Console.WriteLine(string.Join(" ", lst));
      }

   }
}
