﻿using System;
using System.ComponentModel;
using System.Windows.Input;

namespace PersonList.ViewModel {

   public class Person : NotifyPropertyChanged {

      private RelayCommand _cmdUpRate;
      public RelayCommand cmdUpRate { get { return _cmdUpRate ?? (_cmdUpRate = new RelayCommand(() => Rate++, () => _Rate < 10)); } }
      private RelayCommand _cmdDownRate;
      public RelayCommand cmdDownRate { get { return _cmdDownRate ?? (_cmdDownRate = new RelayCommand(() => Rate--, () => _Rate >1)); } }

      private int _Rate = 5;
      public int Rate {
         get { return _Rate; }
         set { ChangePropIfDifferent(value, ref _Rate); }
      }
      private string _Name;
      public string Name {
         get { return _Name; }
         set { ChangePropIfDifferent(value, ref  _Name); }
      }
      private string _Phone;
      public string Phone {
         get { return _Phone; }
         set { ChangePropIfDifferent(value, ref  _Phone); }
      }
      private DateTime _BirthDay;
      public DateTime BirthDay {
         get { return _BirthDay; }
         set { ChangePropIfDifferent(value, ref  _BirthDay); }
      }
      public Person() {
      }
      public Person(string name, string phone, DateTime birth, int rate) {
         _Name = name;
         _Phone = phone;
         _BirthDay = birth;
         _Rate = rate;
      }

      public static Person FromInt(int i) {
         //to create TestData at DesignTime
         return new Person("Person" + i, "54321" + i, DateTime.Today.AddYears(-60 + i), 1 + i % 9);
      }

   }

}
